#ifndef   _CCS_H_
#define   _CCS_H_
/**************************************************************************
 *
 * (C) Copyright 1998 by Novell, Inc.
 * All Rights Reserved.
 *
 * This program is an unpublished copyrighted work which is proprietary
 * to Novell, Inc. and contains confidential information that is not
 * to be reproduced or disclosed to any other person or entity without
 * prior written consent from Novell, Inc. in each and every instance.
 *
 * WARNING:  Unauthorized reproduction of this program as well as
 * unauthorized preparation of derivative works based upon the
 * program or distribution of copies by sale, rental, lease or
 * lending are violations of federal copyright laws and state trade
 * secret laws, punishable by civil and criminal penalties.
 *
 **************************************************************************
 *
 *	  NICI SDK header file for the Controlled Cryptographic Services (CCS)
 *	  cryptographic library (XLIB).
 *
 ***********************************************************************
*/

#ifdef N_PLAT_WNT4
#include <windows.h>
#endif

/* CCS types are based on Novell standard types */
#include <ntypes.h>

#ifdef N_PLAT_WNT4
#undef N_GLOBAL_LIBRARY
#undef N_EXTERN_LIBRARY
#define N_GLOBAL_LIBRARY( retType )    __declspec( dllexport ) retType N_API
#define N_EXTERN_LIBRARY( retType )    _N_EXTERN __declspec( dllexport ) retType N_API
#endif


/* CCS error codes */
#define	CCS_E_EXPIRED						-1499	/* 0xFA25 */
#define	CCS_E_ALREADY_AUTHENTICATED	-1498	/* 0xFA26 */
#define	CCS_E_AUTHENTICATION_FAILURE	-1497	/* 0xFA27 */
#define	CCS_E_NOT_AUTHENTICATED			-1496	/* 0xFA28 */
#define	CCS_E_NO_SERVER_KEY				-1495	/* 0xFA29 */

#define NICI_E_OK											0
#define NICI_E_INTERNAL_ERROR							(-1400) /* 0xFA88 */

#define NICI_E_ALGORITHM_INVALID						(-1401) /* 0xFA87 */
#define NICI_E_ALGORITHM_NOT_SUPPORTED				(-1402) /* 0xFA86 */
#define NICI_E_ASN1_DECODE								(-1403) /* 0xFA85 */
#define NICI_E_ASN1_ENCODE								(-1404) /* 0xFA84 */
#define NICI_E_ATTRIBUTE_READ_ONLY					(-1405) /* 0xFA83 */
#define NICI_E_ATTRIBUTE_SENSITIVE					(-1406) /* 0xFA82 */
#define NICI_E_ATTRIBUTE_TYPE_INVALID				(-1407) /* 0xFA81 */
#define NICI_E_ATTRIBUTE_VALUE_INVALID				(-1408) /* 0xFA80 */
#define NICI_E_BUFFER_OVERFLOW						(-1409) /* 0xFA7F */
#define NICI_E_CC_COUNT									(-1410) /* 0xFA7E */
#define NICI_E_CC_HANDLE_INVALID						(-1411) /* 0xFA7D */
#define NICI_E_CERTIFICATE_CHAIN						(-1412) /* 0xFA7C */
#define NICI_E_CERTIFICATE_DATA_INVALID			(-1413) /* 0xFA7B */
#define NICI_E_CERTIFICATE_DATA_LEN_RANGE			(-1414) /* 0xFA7A */
#define NICI_E_CRITICAL_EXTENSION					(-1415) /* 0xFA79 */
#define NICI_E_DATA_INVALID							(-1416) /* 0xFA78 */
#define NICI_E_DATA_LEN_RANGE							(-1417) /* 0xFA77 */
#define NICI_E_ENCRYPTED_DATA_INVALID				(-1418) /* 0xFA76 */
#define NICI_E_ENCRYPTED_DATA_LEN_RANGE			(-1419) /* 0xFA75 */
#define NICI_E_FLAGS_INVALID							(-1420) /* 0xFA74 */
#define NICI_E_FUNCTION_NOT_SUPPORTED				(-1421) /* 0xFA73 */
#define NICI_E_INVALID_PARAMETER						(-1422) /* 0xFA72 */
#define NICI_E_INVALID_USAGE						 	(-1423) /* 0xFA71 */
#define NICI_E_KEY_HANDLE_INVALID					(-1424) /* 0xFA70 */
#define NICI_E_KEY_PAIR									(-1425) /* 0xFA6F */
#define NICI_E_KEY_POLICY_VIOLATION					(-1426) /* 0xFA6E */
#define NICI_E_KEY_SENSITIVE						 	(-1427) /* 0xFA6D */
#define NICI_E_KEY_SIZE_RANGE							(-1428) /* 0xFA6C */
#define NICI_E_KEY_TYPE_INCONSISTENT				(-1429) /* 0xFA6B */
#define NICI_E_KM_STRENGTH_INVALID				 	(-1430) /* 0xFA6A */
#define NICI_E_MEMORY									(-1431) /* 0xFA69 */
#define NICI_E_NULL_INVALID							(-1432) /* 0xFA68 */
#define NICI_E_OBJECT_CLASS_INCONSISTENT		 	(-1433) /* 0xFA67 */
#define NICI_E_OBJECT_CLASS_INVALID					(-1434) /* 0xFA66 */
#define NICI_E_OBJECT_CLASS_NOT_SUPPORTED			(-1435) /* 0xFA65 */
#define NICI_E_OBJECT_COUNT							(-1436) /* 0xFA64 */
#define NICI_E_OBJECT_HANDLE_INVALID				(-1437) /* 0xFA63 */
#define NICI_E_OBJECT_PERMANENT					 	(-1438) /* 0xFA62 */
#define NICI_E_OPERATION_ACTIVE					 	(-1439) /* 0xFA61 */
#define NICI_E_OPERATION_INCONSISTENT			 	(-1440) /* 0xFA60 */
#define NICI_E_OPERATION_NOT_INITIALIZED		 	(-1441) /* 0xFA5F */
#define NICI_E_RESOURCE									(-1442) /* 0xFA5E */
#define NICI_E_SIGNATURE_INVALID						(-1443) /* 0xFA5D */
#define NICI_E_SIGNATURE_LEN_RANGE				 	(-1444) /* 0xFA5C */
#define NICI_E_TEMPLATE_INCOMPLETE				 	(-1445) /* 0xFA5B */
#define NICI_E_TEMPLATE_INCONSISTENT				(-1446) /* 0xFA5A */
#define NICI_E_UNAVAILABLE								(-1447) /* 0xFA59 */
#define NICI_E_UNWRAPPING_KEY_HANDLE_INVALID		(-1448) /* 0xFA58 */
#define NICI_E_UNWRAPPING_KEY_SIZE_RANGE		 	(-1449) /* 0xFA57 */
#define NICI_E_UNWRAPPING_KEY_TYPE_INCONSISTENT (-1450) /* 0xFA56 */
#define NICI_E_VALIDITY_EXPIRED					  	(-1451) /* 0xFA55 */
#define NICI_E_WRAPPED_KEY_INVALID				  	(-1452) /* 0xFA54 */
#define NICI_E_WRAPPED_KEY_LEN_RANGE				(-1453) /* 0xFA53 */
#define NICI_E_WRAPPING_KEY_HANDLE_INVALID		(-1454) /* 0xFA52 */
#define NICI_E_WRAPPING_KEY_SIZE_RANGE			 	(-1455) /* 0xFA51 */
#define NICI_E_WRAPPING_KEY_TYPE_INCONSISTENT	(-1456) /* 0xFA50 */
#define NICI_E_WRONG_ORDER							 	(-1457) /* 0xFA4F */
#define NICI_E_XS_HANDLE_INVALID					 	(-1458) /* 0xFA4E */
#define NICI_E_XS_RESOURCE							 	(-1459) /* 0xFA4D */

#define NICI_E_NOT_FOUND								(-1460)  /* 0xFA4C */


/* Attribute Type Identifiers */
#define NICI_A_VARIABLELEN 		0x80000000L /* Top bit set in varaible length attributes */
#define NICI_A_SPECIAL	  			0x40000000L /* Special attributes are only set through "special" APIs.*/
#define NICI_A_UNUSED				0				/* The attribute is not intialized */

/* Fv represents a fixed value and Vv represents a variable value*/

#define Fv(x) x
#define Vv(x) (x + NICI_A_VARIABLELEN)

#define NICI_A_ARCHIVE		  	Fv(0x01)
#define NICI_A_ARCHIVE_NAME	Vv(0x02)
#define NICI_A_ARCHIVE_SERIAL Vv(0x03)
#define NICI_A_CA_ISSUER		Vv(0x04)
#define NICI_A_CA_KEYID		 	Vv(0x05)
#define NICI_A_CA_SERIAL		Vv(0x06)
#define NICI_A_CLASS			 	Fv(0x07)
#define NICI_A_DERIV_ID		 	Vv(0x08)
#define NICI_A_EXTENSIONS	  	Vv(0x09)
#define NICI_A_FEATURE		  	Fv(0x0a)
#define NICI_A_FOREIGN		  	Fv(0x0b)
#define NICI_A_GLOBAL			Fv(0x0c)
#define NICI_A_ISSUER			Vv(0x0d)
#define NICI_A_ISSUER_ALT	  	Vv(0x0e)
#define NICI_A_ISSUER_UID	  	Vv(0x0f)
#define NICI_A_KEY_FORMAT	  	Vv(0x10)
#define NICI_A_KEY_ID			Vv(0x11)
#define NICI_A_KEY_NUMBER	  	Fv(0x12)
#define NICI_A_KEY_QUALITY	 	Fv(0x13)
#define NICI_A_KEY_SIZE		 	Fv(0x14)
#define NICI_A_KEY_TYPE		 	Fv(0x15)
#define NICI_A_KEY_USAGE		Fv(0x16)
#define NICI_A_KEY_VALUE		Vv(0x17)
#define NICI_A_MAX_KEY_SIZE	Fv(0x18)
#define NICI_A_MIN_KEY_SIZE	Fv(0x19)
#define NICI_A_OP_USAGE		 	Fv(0x1a)
#define NICI_A_ORIGINAL_DATA  Vv(0x1b)
#define NICI_A_PARTITION		Vv(0x1c)
#define NICI_A_RELOAD			Fv(0x1d)
#define NICI_A_SERIAL			Vv(0x1e)
#define NICI_A_SENSITIVE		Fv(0x1f)
#define NICI_A_SIGN_ALGORITHM Vv(0x20)
#define NICI_A_SIGN_PARAMETER Vv(0x21)
#define NICI_A_SIGN_QUALITY	Fv(0x22)
#define NICI_A_SUBJECT		  	Vv(0x23)
#define NICI_A_SUBJECT_UID	 	Vv(0x24)
#define NICI_A_VALIDITY		 	Vv(0x25)
#define NICI_A_VERSION		  	Vv(0x26)
#define NICI_A_XENG_HANDLE	 	Fv(0x27)

#define NICI_A_SUBJECT_ALT		Vv(0x28)


/* Special Attributes	*/

#define NICI_A_SESSIONKEY	 (NICI_A_SPECIAL + 0x0000434f /* 'CO' */)  /* Value is connection ID */
#define NICI_A_DOMAINKEY	 (NICI_A_SPECIAL + 0x00004E41 /* 'NA'*/ )  /* Value is a name */
#define NICI_A_INTERNAL		 (NICI_A_SPECIAL + 0x0000494) /* 'ID' */)  /* Value is identifier */

/*
	Attribute values (AV) are well know handles to internal objects, objects created inside NICI but
	available outside NICI - the "well known" nici objects.
	They are used in the value of the NICI_A_FEATURE attribute with FindObjects.
*/

#define NICI_AV_CA				(0x01)
#define NICI_AV_DISTRIBUTION  (0x02)
#define NICI_AV_FOREIGN		 	(0x03)
#define NICI_AV_PARTITION	  	(0x04)
#define NICI_AV_SESSION		 	(0x05)
#define NICI_AV_STORAGE		 	(0x06)

/* Object Class Identifiers */
#define NICI_O_POLICY			1
#define NICI_O_CERTIFICATE	 	2
#define NICI_O_SECRET_KEY	  	3
#define NICI_O_PRIVATE_KEY	 	4
#define NICI_O_PUBLIC_KEY	  	5

/* Key & Algorithm Usage Flags */

#define NICI_F_NO_USAGE		 	0L

#define NICI_F_ENCRYPT		  		0x00000001L
#define NICI_F_DECRYPT		  		0x00000002L
#define NICI_F_SIGN			  		0x00000004L
#define NICI_F_SIGN_RECOVER		0x00000008L
#define NICI_F_VERIFY				0x00000010L
#define NICI_F_VERIFY_RECOVER 	0x00000020L
#define NICI_F_WRAP			  		0x00000040L
#define NICI_F_UNWRAP				0x00000080L
#define NICI_F_DERIVE				0x00000100L
#define NICI_F_GENERATE_KEY		0x00000200L
#define NICI_F_GENERATE_KEYPAIR 	0x00000400L
#define NICI_F_DIGEST			  	0x00000800L
#define NICI_F_RANDOM			  	0x00001000L
#define NICI_F_OBFUSCATE		  	0x00002000L

/* Key type flags use upper 4 bits of the flags.*/
#define NICI_F_KEY_TYPE_MASK	 	0xE0000000L
#define NICI_F_KEY_TYPE_NONE	 	0x00000000L
#define NICI_F_KEY_TYPE_SECRET  	0x20000000L
#define NICI_F_KEY_TYPE_PUBLIC  	0x40000000L
#define NICI_F_KEY_TYPE_PRIVATE 	0x80000000L

/* Additional Key Usage Flags */
#define NICI_F_DATA_ENCRYPT		0x00010000L
#define NICI_F_AUTH_ENCRYPT		0x00020000L
#define NICI_F_KM_ENCRYPT		  	0x00040000L
#define NICI_F_LIC_ENCRYPT		 	0x00080000L
#define NICI_F_DATA_DECRYPT		0x00100000L
#define NICI_F_AUTH_DECRYPT		0x00200000L
#define NICI_F_KM_DECRYPT		  	0x00400000L
#define NICI_F_LIC_DECRYPT		 	0x00800000L
#define NICI_F_EXTRACT			  	0x01000000L
#define NICI_F_DISALLOW_GENERATE 0x02000000L

/* Operational Key Usage Flags */

#define NICI_F_NO_OP_USAGE				0L

#define NICI_F_OP_ROOT				 	0x00000001L
#define NICI_F_OP_XENG_SIGN		  	0x00000002L
#define NICI_F_OP_XENG_VERIFY			0x00000004L
#define NICI_F_OP_XLIB_SIGN		  	0x00000008L
#define NICI_F_OP_XLIB_VERIFY			0x00000010L
#define NICI_F_OP_XMGR_SIGN		  	0x00000020L
#define NICI_F_OP_XMGR_VERIFY			0x00000040L
#define NICI_F_OP_CLI_XMGR_SIGN	 	0x00000080L
#define NICI_F_OP_CLI_XMGR_VERIFY  	0x00000100L
#define NICI_F_OP_XMGR_ASST_SIGN		0x00000200L
#define NICI_F_OP_XMGR_ASST_VERIFY 	0x00000400L
#define NICI_F_OP_XSUP_SIGN		  	0x00000800L
#define NICI_F_OP_XSUP_VERIFY			0x00001000L
#define NICI_F_OP_ARCHIVE			 	0x00002000L
#define NICI_F_OP_ARCHIVE_RECOVER  	0x00004000L
#define NICI_F_OP_CA_SIGN			 	0x00008000L
#define NICI_F_OP_CA_VERIFY		  	0x00010000L
#define NICI_F_OP_POLICY_SIGN			0x00020000L
#define NICI_F_OP_POLICY_VERIFY	 	0x00040000L

/************************************************************************/
/*
	NICI_KEY_TYPE values used in NICI_GetPolicyInfo and elsewhere.
*/

#define NICI_K_DES		0x00000001L
#define NICI_K_DES3X 	0x00000002L
#define NICI_K_DH	  		0x00000003L
#define NICI_K_DSA	 	0x00000004L
#define NICI_K_RC2	 	0x00000005L
#define NICI_K_RC4	 	0x00000006L
#define NICI_K_RSA	 	0x00000007L
#define NICI_K_SECRET 	0x00000008L

/*
	The null key types are used for information for the NULL XENG.
*/

#define NICI_K_NULL_SECRET		0x00008000L
#define NICI_K_NULL_PUBLIC		0x00004000L

/************************************************************************/

/* Reserved Object Handle Value */
/*
	These values must always be "-1" in order to be compatible
	with other constants used in checking for valid handles.
*/
#define NICI_H_INVALID 	0xFFFFFFFFL
#define NICI_H_NULL	 	0xFFFFFFFFL

/* Reserved Key Type Value */
#define NICI_K_INVALID	NULL

/* Quality values */
#define NICI_Q_UNKNOWN	0


/* The following data types are unique to NICI */
typedef struct NICI_VERSION
{
	 nuint8   	major;		  /* Integer portion of version*/
	 nuint8   	minor;		  /* hundredths portion of version*/
}NICI_VERSION;

typedef NICI_VERSION N_FAR *NICI_VERSION_PTR;

typedef struct  NICI_VALIDITY
{
	nuint32   	begin;
	nuint32   	end;
}NICI_VALIDITY;

typedef NICI_VALIDITY N_FAR	 *NICI_VALIDITY_PTR;

typedef struct NICI_MODULE_INFO
{
	pnuint8       		modName;
	pnuint8       		fileName;
	NICI_VERSION  		version;
	NICI_VALIDITY 		validity;
}NICI_MODULE_INFO;

typedef NICI_MODULE_INFO	N_FAR  *NICI_MODULE_INFO_PTR;

typedef nuint32   		NICI_CC_HANDLE;
typedef NICI_CC_HANDLE	N_FAR  *NICI_CC_HANDLE_PTR;

typedef nuint32   		NICI_OBJECT_HANDLE;
typedef NICI_OBJECT_HANDLE N_FAR  *NICI_OBJECT_HANDLE_PTR;

typedef nuint32   			NICI_OBJECT_CLASS;
typedef NICI_OBJECT_CLASS  N_FAR  *NICI_OBJECT_CLASS_PTR;

typedef nuint32   			 NICI_ATTRIBUTE_TYPE;
typedef NICI_ATTRIBUTE_TYPE N_FAR *NICI_ATTRIBUTE_TYPE_PTR;

typedef nuint32   			NICI_KEY_TYPE;
typedef NICI_KEY_TYPE		N_FAR  *NICI_KEY_TYPE_PTR;

typedef pnuint8      		NICI_ALGORITHM_ID;
typedef NICI_ALGORITHM_ID  N_FAR *NICI_ALGORITHM_ID_PTR;

typedef nuint32   			NICI_KM_STRENGTH;
typedef NICI_KM_STRENGTH	N_FAR  *NICI_KM_STRENGTH_PTR;

/* These are the values NICI_KM_STRENGTH can take on.*/
#define NICI_KM_UNSPECIFIED	0
#define NICI_KM_NULL				1
#define NICI_KM_EXPORTABLE		2
#define NICI_KM_DOMESTIC		3

/*
	This structure is used when an attribute is an "interger" value.
	Two values are allowed, just for flexibility.
	This structure is 32 bit sensitve because the nuint32    must
	occupy the same space as a pointer in the NICI_ATTRIBUTE structure.
*/

typedef  struct	NICI_FIXED_LEN_ATTRIBUTE
{
	nuint32   	hasValue;		/* Zero if no value has been assigned */
	nuint32   	value;			/* Value, if present. */
	nuint32   	valueInfo;		/* Optional field specific to a type*/
}NICI_FIXED_LEN_ATTRIBUTE;

typedef struct	 NICI_VAR_LEN_ATTRIBUTE
{
	nptr            	valuePtr;
	nuint32   		valueLen;
	nuint32   		valueInfo;	/* Optional field specific to a type*/
}NICI_VAR_LEN_ATTRIBUTE;

typedef struct NICI_ATTRIBUTE
{
	NICI_ATTRIBUTE_TYPE type;	/* High bit set if fixed length types*/
	union
	{
	  NICI_FIXED_LEN_ATTRIBUTE f; /* Fixed length attribute */
	  NICI_VAR_LEN_ATTRIBUTE	v; /* Variable length attribute */
	}u;
}NICI_ATTRIBUTE;


typedef NICI_ATTRIBUTE N_FAR	*NICI_ATTRIBUTE_PTR;

typedef  nuint32   	 NICI_ALGORITHM_HANDLE;
typedef  NICI_ALGORITHM_HANDLE N_FAR *NICI_ALGORITHM_HANDLE_PTR;

typedef enum NICI_PACKET_SIGN_CONST {PS_RESET=0, PS_CURRENT_UPDATE, PS_CURRENT_NOUPDATE, PS_PREVIOUS_UPDATE, PS_PREVIOUS_NOUPDATE}NICI_PACKET_STATE;

/************************************************************************/

/*
	Parameter information is exchanged between the XMGR and XENG to convey
	information about any special parameters needed by a particular algorithm.

	The defined parameter types are algorithm specific.

	Allocate a NICI_PARAMETER_INFO structure with enough space to hold
	as many NICI_PARAMETER_DATA structures as are needed to satisfy the
	count.

	Those parameters with the NICI_P_VARIABLE flag set rquire the pointer
	and length (the struct Block part of the union) when used as input
	parameters.  The others use only the value, since they are integers.
*/

#define NICI_P_VARIABLE 0x80000000L
#define NICI_P_BASE	 	(NICI_P_VARIABLE + 1)
#define NICI_P_DH_PK		(NICI_P_VARIABLE + 2)
#define NICI_P_EFF_BITS 3
#define NICI_P_IV			(NICI_P_VARIABLE + 4)	/* exactly 8 byte IV */
#define NICI_P_PRIME		(NICI_P_VARIABLE + 5)
#define NICI_P_SUBPRIME (NICI_P_VARIABLE + 6)
#define NICI_P_SALT	 	(NICI_P_VARIABLE + 7)
#define NICI_P_COUNT	 	8

typedef struct NICI_PARAMETER_DATA
{
	nuint32   	parmType;
	union
	{
	  nuint32   	value;

	  struct Range
	  {
		 nuint32   	min;
		 nuint32   	max;
	  }r;

		struct Block
	  {
		 nuint32   		len;
		 pnuint8      	ptr;
	  }b;
	}u;
}NICI_PARAMETER_DATA;

typedef NICI_PARAMETER_DATA *NICI_PARAMETER_DATA_PTR;

typedef struct NICI_PARAMETER_INFO
{
	nuint32   				count;  /* Count of elements in the parameter array */
	NICI_PARAMETER_DATA 	parms[1];	/* An array of NICI_PARAMETER_DATA starts here */
}NICI_PARAMETER_INFO;

typedef NICI_PARAMETER_INFO N_FAR					*NICI_PARAMETER_INFO_PTR;

/************************************************************************/

typedef struct NICI_ALGORITHM
{
	 NICI_ALGORITHM_ID	algorithm;
	 NICI_PARAMETER_INFO N_FAR	*parameter;
	 nuint32   				parameterLen;
} NICI_ALGORITHM;

typedef NICI_ALGORITHM N_FAR	*NICI_ALGORITHM_PTR;

typedef struct NICI_ALGORITHM_INFO
{
	NICI_OBJECT_HANDLE	algHandle;
	NICI_KEY_TYPE			keyType;
	nflag32   	  			usages;
	nuint32   	  			mayRepeat; /* May call update after final*/
	nuint32   	  			mayRestart;/* May call init after final		*/
	nuint32   	  			blockLen;
	nuint32   	  			algIDLen;
	nuint32   	  			keyFmtLen;
	nuint32   	  			parmCount;
	nuint32   	  			minKeySize;	  /* Minimum valid size.  Zero if no key is used */
	nuint32   	  			maxKeySize;	  /* Maximum valid size.  Zero if no key is used */
} NICI_ALGORITHM_INFO;

typedef NICI_ALGORITHM_INFO N_FAR *NICI_ALGORITHM_INFO_PTR;

typedef nuint32   					 NICI_QUALITY;
typedef NICI_QUALITY N_FAR			*NICI_QUALITY_PTR;

/*
 *		 The following define standard NICI object identifiers.
 *		 These arrays will be defined by the caller in a C module.
 *		 They should be initialized as shown in the comments.
*/

/*
	NOVELL_OID is registered with ANSI.

	NOVELL OID := {joint-iso-ccitt(2) country(16) US(840) organization (1) novell(113719)}
	concatenated with
	Applications OID := {novell applications(1)}
	security OID := {applications security(2)}

	In what follows:
	NOVELL_OID is the ASN1 base for NOVELL.		It is further qualified:
	NICI_OID_A is for application security attributes.
	NICI_OID_O is for application security objects.
	NICI_OID_ALG is for application security algorithms.

	Note that the second byte of the ID is a count of the number of bytes
	that follow.  The defintions given below are based on knowledge that
	the identifiers have 11 (0x0b) or 12 (0x0c) bytes.

	The defines with "_LOID" are 12 byte long, those with "OID" are 11 bytes long.

	The integer values in some identifiers are coded base 128 (in standard
	ASN.1 Integer formats) with the high bit set in each byte except the last.
	(See The PKCS Standards documents from RSA:  A Layman's Guide to a Subset
	of ASN.1, BER and DER.

	TB is a macro which produces a two byte intger value in the format just
	described.
*/

#define TB(N)  (0x80 | (N / 128)), (N % 128)


#define NOVELL_OID  0x06, 0x0B, 0x60, 0x86, 0x48, 0x01, 0x86, 0xF8, 0x37
#define NOVELL_LOID 0x06, 0x0C, 0x60, 0x86, 0x48, 0x01, 0x86, 0xF8, 0x37

#define NICI_OID_A	NOVELL_OID,  0x01, 0x02, 0x04
#define NICI_LOID_A	NOVELL_LOID, 0x01, 0x02, 0x04

#define NICI_OID_O	NOVELL_OID,  0x01, 0x02, 0x06
#define NICI_LOID_O	NOVELL_LOID, 0x01, 0x02, 0x06

#define NICI_OID_ALG  NOVELL_OID,  0x01, 0x02, 0x08
#define NICI_LOID_ALG NOVELL_LOID, 0x01, 0x02, 0x08

/* certificate associated OIDs */
N_EXTERN_VAR nuint8    NICI_OID_KEY_USAGE[]; 	/* = {NICI_OID_A, 9};	  */
N_EXTERN_VAR nuint8    NICI_OID_KEY_QUALITY[]; 	/* = {NICI_OID_A, 18};	 */
N_EXTERN_VAR nuint8    NICI_OID_SIGN_QUALITY[]; /* = {NICI_OID_A, 19};	 */


/************************************************************************/
/*
**		The definitions begining IDV are RESERVED FOR NOVELL INTERNAL USE.
**		There is no guarantee that any of these values are actually supported
** by a particular NICI implementation.
**
** The external byte arrays identified as NICI_OID are also reserved for
** future use.  They are intended to suggest standard names for referring
** to the IDV values.
**
** Most of the IDV and NICI_OID definitions are commented out to prevent
** their accidental implementation.  Uncomment them as they are needed.
*/
/************************************************************************/

/* These algorithm ID defintions are useful for initializations.*/

#define IDV_NULL		  	NICI_OID_ALG, 1 /* 0x01*/
#define IDV_NULL_SECRET NICI_OID_ALG, 2 /* 0x02*/
#define IDV_NULL_PUBLIC NICI_OID_ALG, 3 /* 0x03*/

/************************************************************************/

/*
	These IDVs correspond to all of the AI values from BSAFE 3.0.
	They are defined here for completeness but only a few will ever
	be exported.
*/

#if 0
	These IDVs are not used yet.
	Convention is to indent those that are not implmented so that
	those that are implemented stand out.

	#define IDV_BSSecretSharing				NICI_OID_ALG, 20 /* 0x14 */
	#define IDV_CBC_IV8							NICI_OID_ALG, 21 /* 0x15 */
#endif /* Not needed yet. */

#define IDV_DES_CBC_IV8				  			NICI_OID_ALG, 22 /* 0x16 */ 

#define IDV_DES_CBCPadIV8						NICI_OID_ALG, 23 /* 0x17 */

#if 0 /* Not needed yet. */
	#define IDV_DES_CBCPadBER					NICI_OID_ALG, 24 /* 0x18 */
	#define IDV_DES_CBCPadPEM					NICI_OID_ALG, 25 /* 0x19 */
#endif

#define IDV_DES_EDE3_CBC_IV8					NICI_OID_ALG, 26 /* 0x1a */

#define IDV_DES_EDE3_CBCPadIV8				NICI_OID_ALG, 27 /* 0x1b */

#if 0 /* Not needed yet. */
	#define IDV_DES_EDE3_CBCPadBER			NICI_OID_ALG, 28 /* 0x1c */
	#define IDV_DESX_CBC_IV8					NICI_OID_ALG, 29 /* 0x1d */
	#define IDV_DESX_CBCPadIV8					NICI_OID_ALG, 30 /* 0x1e */
	#define IDV_DESX_CBCPadBER					NICI_OID_ALG, 31 /* 0x1f */
	#define IDV_DHKeyAgree						NICI_OID_ALG, 32 /* 0x20 */
	#define IDV_DHKeyAgreeBER					NICI_OID_ALG, 33 /* 0x21 */
	#define IDV_DHParamGen						NICI_OID_ALG, 34 /* 0x22 */
	#define IDV_DSA								NICI_OID_ALG, 35 /* 0x23 */
	#define IDV_DSAKeyGen						NICI_OID_ALG, 36 /* 0x24 */
	#define IDV_DSAParamGen						NICI_OID_ALG, 37 /* 0x25 */
	#define IDV_DSAWithSHA1						NICI_OID_ALG, 38 /* 0x26 */
	#define IDV_DSAWithSHA1_BER				NICI_OID_ALG, 39 /* 0x27 */
#endif /* Not needed yet. */

#define IDV_MD2									NICI_OID_ALG, 40 /* 0x28 */

#if 0 /* Not needed yet. */
	#define IDV_MD2Random						NICI_OID_ALG, 41 /* 0x29 */
	#define IDV_MD2WithDES_CBCPad				NICI_OID_ALG, 42 /* 0x2a */
	#define IDV_MD2WithDES_CBCPadBER			NICI_OID_ALG, 43 /* 0x2b */
	#define IDV_MD2WithRC2_CBCPad				NICI_OID_ALG, 44 /* 0x2c */
	#define IDV_MD2WithRC2_CBCPadBER			NICI_OID_ALG, 45 /* 0x2d */
	#define IDV_MD2WithRSAEncryption			NICI_OID_ALG, 46 /* 0x2e */
	#define IDV_MD2WithRSAEncryptionBER 	NICI_OID_ALG, 47 /* 0x2f */
	#define IDV_MD2_BER							NICI_OID_ALG, 48 /* 0x30 */
	#define IDV_MD2_PEM							NICI_OID_ALG, 49 /* 0x31 */
#endif /* Not needed yet. */

#define IDV_MD5							 		NICI_OID_ALG, 50 /* 0x32 */

#if 0 /* Not needed yet.*/
	#define IDV_MD5Random						NICI_OID_ALG, 51 /* 0x33 */
	#define IDV_MD5WithDES_CBCPad		  		NICI_OID_ALG, 52 /* 0x34 */
	#define IDV_MD5WithDES_CBCPadBER	  		NICI_OID_ALG, 53 /* 0x35 */
	#define IDV_MD5WithRC2_CBCPad		  		NICI_OID_ALG, 54 /* 0x36 */
	#define IDV_MD5WithRC2_CBCPadBER	  		NICI_OID_ALG, 55 /* 0x37 */
	#define IDV_MD5WithRSAEncryption	  		NICI_OID_ALG, 56 /* 0x38 */
	#define IDV_MD5WithRSAEncryptionBER 	NICI_OID_ALG, 57 /* 0x39 */
	#define IDV_MD5WithXOR						NICI_OID_ALG, 58 /* 0x3a */
	#define IDV_MD5WithXOR_BER			 		NICI_OID_ALG, 59 /* 0x3b */
	#define IDV_MD5_BER							NICI_OID_ALG, 60 /* 0x3c */
	#define IDV_MD5_PEM							NICI_OID_ALG, 61 /* 0x3d */
	#define IDV_PKCS_RSAPrivate				NICI_OID_ALG, 62 /* 0x3e */
	#define IDV_PKCS_RSAPrivateBER			NICI_OID_ALG, 63 /* 0x3f */
	#define IDV_PKCS_RSAPrivatePEM			NICI_OID_ALG, 64 /* 0x40 */
	#define IDV_PKCS_RSAPublic			  		NICI_OID_ALG, 65 /* 0x41 */
	#define IDV_PKCS_RSAPublicBER		  		NICI_OID_ALG, 66 /* 0x42 */
	#define IDV_PKCS_RSAPublicPEM		  		NICI_OID_ALG, 67 /* 0x43 */
	#define IDV_RC2_CBC							NICI_OID_ALG, 68 /* 0x44 */ /* Use RSADSI_RC2CBC*/
#endif /* Not needed yet. */

#define IDV_RC2_CBCPad							NICI_OID_ALG, 69 /* 0x45 */

#if 0 /* Not needed yet. */
	#define IDV_RC2_CBCPadBER					NICI_OID_ALG, 70 /* 0x46 */
	#define IDV_RC2_CBCPadPEM					NICI_OID_ALG, 71 /* 0x47 */
	#define IDV_RC4								NICI_OID_ALG, 72 /* 0x48 */ /* Use RSADSI_RC4 */
	#define IDV_RC4WithMAC						NICI_OID_ALG, 73 /* 0x49 */
	#define IDV_RC4WithMAC_BER			  		NICI_OID_ALG, 74 /* 0x4a */
	#define IDV_RC4_BER							NICI_OID_ALG, 75 /* 0x4b */
	#define IDV_RC5_CBC							NICI_OID_ALG, 76 /* 0x4c */
	#define IDV_RC5_CBCPad						NICI_OID_ALG, 77 /* 0x4d */
	#define IDV_RFC1113Recode					NICI_OID_ALG, 78 /* 0x4e */
	#define IDV_RSAKeyGen						NICI_OID_ALG, 79 /* 0x4f */
	#define IDV_RSAPrivate						NICI_OID_ALG, 80 /* 0x50 */
	#define IDV_RSAPublic						NICI_OID_ALG, 81 /* 0x51 */
#endif /* Not needed yet. */

#define IDV_SHA1									NICI_OID_ALG, 82 /* 0x52 */

#if 0 /* Not needed yet. */
	#define IDV_SHA1_BER					  		NICI_OID_ALG, 83 /* 0x53 */
	#define IDV_SHA1WithDES_CBCPad			NICI_OID_ALG, 84 /* 0x54 */
	#define IDV_SHA1WithDES_CBCPadBER		NICI_OID_ALG, 85 /* 0x55 */
	#define IDV_SHA1WithRSAEncryption		NICI_OID_ALG, 86 /* 0x56 */
	#define IDV_SHA1WithRSAEncryptionBER	NICI_OID_ALG, 87 /* 0x57 */

	/*
		Algorithm Info Types for BSAFE 1.x Support.
	*/

	#define IDV_DES_CBC_BSAFE1					NICI_OID_ALG, 88 /* 0x58 */
	#define IDV_DESX_CBC_BSAFE1  				NICI_OID_ALG, 89 /* 0x59 */
	#define IDV_MAC				  				NICI_OID_ALG, 90 /* 0x5A */
	#define IDV_MD									NICI_OID_ALG, 91 /* 0x5B */
#endif /* Not needed yet. */

#define IDV_RC2_CBC_BSAFE1						NICI_OID_ALG, 92 /* 0x5C */

#if 0 /* Not needed yet. */
	#define IDV_RSAPrivateBSAFE1 				NICI_OID_ALG, 93 /* 0x5D */
	#define IDV_RSAPublicBSAFE1  				NICI_OID_ALG, 94 /* 0x5E */

	/*
		Algorithm Info Types added to support existing Novell products but not
		now supported by BSAFE.
	*/

#endif /* Not needed yet. */

#define IDV_MD4 									NICI_OID_ALG, 95 /* 0x5F */
#define IDV_NOV_MD4_NOPAD						NICI_OID_ALG, 96 /* 0x60 */

#if 0 /* Not needed yet. */


#endif /* Unused IDVs*/

/*
	Generic IDs used by NICI to represent groups of BSAFE info types.
	These IDs have a two byte value after the basic Novell algorithm ID.
	The high bit in the first byte is set and the rest of the two bytes
	are a base 128 representation of the ID value.
*/

#define IDV_NOV_MD4_PACKET  	NICI_LOID_ALG, TB(130) /* 0x81, 0x02 MD4 variant for packet signature*/
#define IDV_NOV_RSA_BSAFE1  	NICI_LOID_ALG, TB(131) /* 0x81, 0x03 old NDS BSAFE1 (B_BSAFE1_PAD_CHECKSUM)*/
#define IDV_NOV_NW_PASSWORD 	NICI_LOID_ALG, TB(132) /* 0x81, 0x04 NW password hash */
#define IDV_NOV_OBFUSCATE_1 	NICI_LOID_ALG, TB(133) /* 0x81, 0x05 Novell obfuscation*/
#define IDV_NOV_MABLE_SIGN_1	NICI_LOID_ALG,	TB(134) /* 0x81, 0x06 Mable SHA1 RSA Raw Encrypt Signature */
#define IDV_NOV_RSA_BSAFE1Pad NICI_LOID_ALG, TB(135) /* 0x81, 0x07 RSA BSAFE1 (B_BSAFE1_PAD)*/

/************************************************************************/

/************************************************************************/
/* These external declarations are for use by the XENG, XMGR, and XLIBS.*/
/* They are declared here to encourage the use of standard names within */
/* all the modules.																																															*/
/* They correspond to the IDVs defined above and should be initialized  */
/* to that IDV when used.																																										 */
/*																																																															 */
/* For example: nuint8    NICI_OID_NULL[] = {IDV_NULL};													  */
/*																																																												  */
/* Most of these are commented out to prevent their accidental use.				 */
/* Uncomment them as needed.																																						  */
/*																																																															 */
/************************************************************************/

N_EXTERN_VAR nuint8    NICI_OID_NULL[];
N_EXTERN_VAR nuint8    NICI_OID_NULL_SECRET[];
N_EXTERN_VAR nuint8    NICI_OID_NULL_PUBLIC[];


#if 0
	Unused for now.
	Convention is to indent those that are Not needed yet. so
	that those that are implemented stand out.

	N_EXTERN_VAR nuint8    NICI_OID_BSSecretSharing[];
	N_EXTERN_VAR nuint8    NICI_OID_CBC_IV8[];
#endif /* Not needed yet.*/

N_EXTERN_VAR nuint8    NICI_OID_DES_CBC_IV8[];

#if 0 /*Not needed yet.*/
	N_EXTERN_VAR nuint8    NICI_OID_DES_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_DES_CBCPadPEM[];
#endif

N_EXTERN_VAR nuint8    NICI_OID_DES_EDE3_CBC_IV8[];

#if 0 /* Not needed yet.*/
	N_EXTERN_VAR nuint8    NICI_OID_DES_EDE3_CBCPadIV8[];
	N_EXTERN_VAR nuint8    NICI_OID_DES_EDE3_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_DES_CBCPadIV8[];
	N_EXTERN_VAR nuint8    NICI_OID_DESX_CBC_IV8[];
	N_EXTERN_VAR nuint8    NICI_OID_DESX_CBCPadIV8[];
	N_EXTERN_VAR nuint8    NICI_OID_DESX_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_DHKeyAgree[];
	N_EXTERN_VAR nuint8    NICI_OID_DHKeyAgreeBER[];
	N_EXTERN_VAR nuint8    NICI_OID_DHParamGen[];
	N_EXTERN_VAR nuint8    NICI_OID_DSA[];
	N_EXTERN_VAR nuint8    NICI_OID_DSAKeyGen[];
	N_EXTERN_VAR nuint8    NICI_OID_DSAParamGen[];
	N_EXTERN_VAR nuint8    NICI_OID_DSAWithSHA1[];
	N_EXTERN_VAR nuint8    NICI_OID_DSAWithSHA1_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2Random[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2WithDES_CBCPad[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2WithDES_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2WithRC2_CBCPad[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2WithRC2_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2WithRSAEncryption[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2WithRSAEncryptionBER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD2_PEM[];
#endif /* Not needed yet. */

N_EXTERN_VAR nuint8    NICI_OID_MD5[];

#if 0 /* Not needed yet. */
	N_EXTERN_VAR nuint8    NICI_OID_MD5Random[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithDES_CBCPad[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithDES_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithRC2_CBCPad[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithRC2_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithRSAEncryption[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithRSAEncryptionBER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithXOR[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5WithXOR_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_MD5_PEM[];
	N_EXTERN_VAR nuint8    NICI_OID_PKCS_RSAPrivate[];
	N_EXTERN_VAR nuint8    NICI_OID_PKCS_RSAPrivateBER[];
	N_EXTERN_VAR nuint8    NICI_OID_PKCS_RSAPrivatePEM[];
	N_EXTERN_VAR nuint8    NICI_OID_PKCS_RSAPublic[];
	N_EXTERN_VAR nuint8    NICI_OID_PKCS_RSAPublicBER[];
	N_EXTERN_VAR nuint8    NICI_OID_PKCS_RSAPublicPEM[];
	N_EXTERN_VAR nuint8    NICI_OID_RC2_CBC[];
#endif /* Not needed yet. */

N_EXTERN_VAR nuint8    NICI_OID_RC2_CBCPad[];

#if 0 /* Not needed yet. */
	N_EXTERN_VAR nuint8    NICI_OID_RC2_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_RC2_CBCPadPEM[];
	N_EXTERN_VAR nuint8    NICI_OID_RC4[];
	N_EXTERN_VAR nuint8    NICI_OID_RC4WithMAC[];
	N_EXTERN_VAR nuint8    NICI_OID_RC4WithMAC_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_RC4_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_RC5_CBC[];
	N_EXTERN_VAR nuint8    NICI_OID_RC5_CBCPad[];
	N_EXTERN_VAR nuint8    NICI_OID_RFC1113Recode[];
	N_EXTERN_VAR nuint8    NICI_OID_RSAKeyGen[];
	N_EXTERN_VAR nuint8    NICI_OID_RSAPrivate[];
	N_EXTERN_VAR nuint8    NICI_OID_RSAPublic[];

#if 0
	N_EXTERN_VAR nuint8    NICI_OID_SHA1[];
#endif

	N_EXTERN_VAR nuint8    NICI_OID_SHA1_BER[];
	N_EXTERN_VAR nuint8    NICI_OID_SHA1WithDES_CBCPad[];
	N_EXTERN_VAR nuint8    NICI_OID_SHA1WithDES_CBCPadBER[];
	N_EXTERN_VAR nuint8    NICI_OID_SHA1WithRSAEncryption[];
	N_EXTERN_VAR nuint8    NICI_OID_SHA1WithRSAEncryptionBER[];

	N_EXTERN_VAR nuint8    NICI_OID_DES_CBC_BSAFE1[];
	N_EXTERN_VAR nuint8    NICI_OID_DESX_CBC_BSAFE1[];
	N_EXTERN_VAR nuint8    NICI_OID_MAC[];
	N_EXTERN_VAR nuint8    NICI_OID_MD[];
#endif

N_EXTERN_VAR nuint8    NICI_OID_RC2_CBC_BSAFE1[];

#if 0
	N_EXTERN_VAR nuint8    NICI_OID_RSAPrivateBSAFE1[];
	N_EXTERN_VAR nuint8    NICI_OID_RSAPublicBSAFE1[];

#endif /* Not needed yet. */

N_EXTERN_VAR nuint8    NICI_OID_MD4[];
N_EXTERN_VAR nuint8    NICI_OID_NOV_MD4_NOPAD[];

#if 0 /* Not needed yet. */

#endif /* Unused stuff*/

N_EXTERN_VAR nuint8    NICI_OID_NOV_MD4_PACKET[];
N_EXTERN_VAR nuint8    NICI_OID_NOV_RSA_BSAFE1[];
N_EXTERN_VAR nuint8    NICI_OID_NOV_RSA_BSAFE1Pad[];
N_EXTERN_VAR nuint8    NICI_OID_NOV_NW_PASSWORD[];
N_EXTERN_VAR nuint8    NICI_OID_NOV_OBFUSCATE[];
N_EXTERN_VAR nuint8    NICI_OID_NOV_MABLE_SIGN_1[]; 

/************************************************************************/

/************************************************************************/
/* PKCS compliant algorithm identifiers.																													 */
/************************************************************************/
/*
** These OIDs are defined to be interoperable with PKCS #1.
**  Their implementation in the XENGs are specific to that standard.
**
**  The values for these OIDs were taken from the PKCS documentation.
*/
/************************************************************************/
/* pkcs-1 (1 2 840 113549 1 1) */
#define PKCS1_PREFIX 0x06, 0x08, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01

/* The PKCS1_OID has a length of 9 so that it can be extended by one byte */
#define PKCS1_OID		 0x06, 0x09, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0D, 0x01, 0x01

/* rsaEncryption (1 2 840 113549 1 1 1) */
#define PKCS1_rsaEncryption PKCS1_OID, 1

/* md2withRSAEncryption (1 2 840 113549 1 1 2) */
#define PKCS1_md2withRSAEncryption PKCS1_OID, 2

/* md5withRSAEncryption (1 2 840 113549 1 1 4) */
#define PKCS1_md5withRSAEncryption PKCS1_OID, 4

/* sha1withRSAEncryption (1 2 840 113549 1 1 5) */
#define PKCS1_sha1withRSAEncryption PKCS1_OID, 5


N_EXTERN_VAR nuint8    OID_PKCS1_rsaEncryption[];
N_EXTERN_VAR nuint8    OID_PKCS1_md2withRSAEncryption[];
N_EXTERN_VAR nuint8    OID_PKCS1_md5withRSAEncryption[];
N_EXTERN_VAR nuint8    OID_PKCS1_sha1withRSAEncryption[];

/************************************************************************/
/************************************************************************/



/************************************************************************/
/************************************************************************/
/*
	These OIDs are defined by RSA Data Security, Inc. for their algorithms.
*/
/************************************************************************/
/*
	RSADSI digestAlgorithm (1 2 840 113549 2) prefix
	RSADSI encryptionAlgorithm (1 2 840 113549 3) prefix
*/


#define RSADSI_DIGEST  0x06, 0x08, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0d, 0x02
#define RSADSI_ENCRYPT 0x06, 0x08, 0x2A, 0x86, 0x48, 0x86, 0xF7, 0x0d, 0x03

/* rc2CBC (1 2 840 113549 3 2)*/
#define RSADSI_RC2CBC RSADSI_ENCRYPT, 0x02

/* rc4 (1 2 840 113549 3 4) */
#define RSADSI_RC4 RSADSI_ENCRYPT, 0x04


N_EXTERN_VAR nuint8    OID_RSADSI_RC4[];	  /* initialize with RSADSI_RC4 - BSAFE AI_RC4 non-BER key*/
N_EXTERN_VAR nuint8    OID_RSADSI_RC2CBC[];  /* initialize with RSADSI_RC2CBC*/

/************************************************************************/


/* CCS function prototypes - alphabetical by function name */

N_EXTERN_LIBRARY(int)
CCS_CreateContext(
	nflag32   						flags,
	NICI_CC_HANDLE_PTR	  		cryptoContext);

N_EXTERN_LIBRARY(int)
CCS_DataDecryptInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_DataEncryptInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_Decrypt(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					encryptedData,
	nuint32   						encryptedDataLen,
	pnuint8      					data,
	pnuint32      					dataLen);

N_EXTERN_LIBRARY(int)
CCS_DecryptFinal(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					lastDecryptedPart,
	pnuint32      					lastDecryptedPartLen);

N_EXTERN_LIBRARY(int)
CCS_DecryptRestart(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE	  		key);

N_EXTERN_LIBRARY(int)
CCS_DecryptUpdate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					part,
	nuint32   						partLen,
	pnuint8      					decryptedPart,
	pnuint32      					decryptedPartLen);

N_EXTERN_LIBRARY(int)
CCS_DeObfuscate(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					clearData,
	pnuint32      					clearDataLen);

N_EXTERN_LIBRARY(int)
CCS_DestroyContext(
	NICI_CC_HANDLE					cryptoContext);

N_EXTERN_LIBRARY(int)
CCS_DestroyObject(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			object);

N_EXTERN_LIBRARY(int)
CCS_Digest(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					digest,
	pnuint32      					digestLen);

N_EXTERN_LIBRARY(int)
CCS_DigestFinal(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					digest,
	pnuint32      					digestLen);

N_EXTERN_LIBRARY(int)
CCS_DigestInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR	  		algorithm);

N_EXTERN_LIBRARY(int)
CCS_DigestRestart(
	NICI_CC_HANDLE					cryptoContext);

N_EXTERN_LIBRARY(int)
CCS_DigestUpdate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					part,
	nuint32   						partLen);

N_EXTERN_LIBRARY(int)
CCS_Encrypt(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					encryptedData,
	pnuint32      					encryptedDataLen);

N_EXTERN_LIBRARY(int)
CCS_EncryptFinal(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					lastEncryptedPart,
	pnuint32      					lastEncryptedPartLen);

N_EXTERN_LIBRARY(int)
CCS_EncryptRestart(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_EncryptUpdate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					part,
	nuint32   						partLen,
	pnuint8      					encryptedPart,
	pnuint32      					encryptedPartLen);

N_EXTERN_LIBRARY(int)
CCS_FindObjects(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE_PTR		object,
	pnuint32      					objectCount);

N_EXTERN_LIBRARY(int)
CCS_FindObjectsInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ATTRIBUTE_PTR			findTemplate,
	nuint32   						attributeCount);

N_EXTERN_LIBRARY(int)
CCS_GenerateCertificate(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			signatureAlgorithm,
	NICI_OBJECT_HANDLE			signatureKey,
	NICI_OBJECT_HANDLE			issuerCertificate,
	NICI_OBJECT_HANDLE			key,
	NICI_ATTRIBUTE_PTR			attributeTemplate,
	nuint32   						attributeCount,
	NICI_OBJECT_HANDLE_PTR		certificate,
	pnuint8      					certificateData,
	pnuint32      					certificateDataLen);

N_EXTERN_LIBRARY(int)
CCS_GenerateCertificateFromRequest(
	NICI_CC_HANDLE 				cryptoContext,
	NICI_OBJECT_HANDLE 			signKeyH,
	NICI_OBJECT_HANDLE			issuerCertificate,
	pnuint8       					CSR,
	nuint32    						CSRLen,
	NICI_ATTRIBUTE_PTR			attributeTemplate,
	nuint32   						attributeCount,
	NICI_OBJECT_HANDLE_PTR		certificate,
	pnuint8      					certData,
   pnuint32      					certDataLen);

N_EXTERN_LIBRARY(int)
CCS_GenerateKey(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_ATTRIBUTE_PTR			attributeTemplate,
	nuint32   						attributeCount,
	pnbool8					sizeChanged,
	NICI_OBJECT_HANDLE_PTR		key,
	nuint32   						archive);

N_EXTERN_LIBRARY(int)
CCS_GenerateKeyPair(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_ATTRIBUTE_PTR			attributeTemplate,
	nuint32   						attributeCount,
	pnbool8					sizeChanged,
	NICI_OBJECT_HANDLE_PTR		publicKey,
	NICI_OBJECT_HANDLE_PTR		privateKey,
	nuint32   						archive);

N_EXTERN_LIBRARY(int)
CCS_GetAlgorithmInfo(
	NICI_ALGORITHM_ID				algorithm,
	NICI_ALGORITHM_INFO_PTR		algorithmInfo);

N_EXTERN_LIBRARY(int)
CCS_GetAlgorithmList(
	NICI_ALGORITHM_INFO_PTR		algInfoList,
	pnuint32      					count);

N_EXTERN_LIBRARY(int)
CCS_GetAttributeValue(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			object,
	NICI_ATTRIBUTE_PTR			attrTemplate,
	nuint32   						count);

N_EXTERN_LIBRARY(int)
CCS_GetCertificate(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			key,
	pnuint8      					certificateData,
	pnuint32      					certificateDataLen,
	NICI_OBJECT_HANDLE_PTR		issuerKey);

N_EXTERN_LIBRARY(int)
CCS_GetDefaultAlgorithmInfo(
	nflag32   						algorithmUsage,
	NICI_ATTRIBUTE_PTR			keyAttributes,
	nuint32   						keyAttributeCount,
	NICI_ALGORITHM_INFO_PTR		algorithmInfo);

N_EXTERN_LIBRARY(int)
CCS_GetInfo(
	NICI_VERSION_PTR				version,
	pnuint8      					serial,
	pnuint32      					serialLen);

N_EXTERN_LIBRARY(int)
CCS_GetKMStrength(
	NICI_KM_STRENGTH_PTR			level);

N_EXTERN_LIBRARY(int)
CCS_GetModuleInfo(
	NICI_MODULE_INFO_PTR			info,
	pnuint32      					count);

N_EXTERN_LIBRARY(int)
CCS_GetMoreAlgorithmInfo(
	NICI_OBJECT_HANDLE			algHandle,
	NICI_ALGORITHM_ID_PTR		algID,
	NICI_ALGORITHM_ID_PTR		keyFormat,
	NICI_PARAMETER_INFO_PTR		parameters);

N_EXTERN_LIBRARY(int)
CCS_GetPolicyInfo(
	NICI_KEY_TYPE				 	keyType,
	nflag32   						keyUsage,
	pnuint32      					maxKeySize,
	pnuint32      					minKeySize,
	pnuint32      					archiveType,
	pnuint8      					archiveRqmts,
	pnuint32      					archiveRqmtsLen);

N_EXTERN_LIBRARY(int)
CCS_GetRandom(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					buffer,
	nuint32   						length);

N_EXTERN_LIBRARY(int)
CCS_Init(
	nptr                          moduleID);

N_EXTERN_LIBRARY(int)
CCS_LoadBinderySessionKey(
	pnuint8      					passwordHash,
	pnuint8      					loginChallenge,
	NICI_OBJECT_HANDLE_PTR		key);

N_EXTERN_LIBRARY(int)
CCS_LoadCertificate(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			verificationKey,
	pnuint8      					certificateData,
	nuint32   						certificateDataLen,
	NICI_ATTRIBUTE_PTR			template,
	nuint32   						attributeCount,
	NICI_OBJECT_HANDLE_PTR		certificate,
	NICI_OBJECT_HANDLE_PTR		key);

N_EXTERN_LIBRARY(int)
CCS_LoadSelfSignedCertificate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					certificateData,
	nuint32   						certificateDataLen,
	NICI_ATTRIBUTE_PTR			template,
	nuint32   						attributeCount,
	NICI_OBJECT_HANDLE_PTR		certificate,
	NICI_OBJECT_HANDLE_PTR		key);

N_EXTERN_LIBRARY(int)
CCS_LoadUnverifiedCertificate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					certificateData,
	nuint32   						certificateDataLen,
	NICI_ATTRIBUTE_PTR			template,
	nuint32   						attributeCount,
	NICI_OBJECT_HANDLE_PTR		certificate,
	NICI_OBJECT_HANDLE_PTR		key);

N_EXTERN_LIBRARY(int)
CCS_Obfuscate(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					obfuscatedData,
	pnuint32      					obfuscatedDataLen);

N_EXTERN_LIBRARY(int)
CCS_PacketReplySign(
	NICI_CC_HANDLE					cryptoContext,
	nuint32   						encodedLen,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					signature,
	pnuint32      					signatureLen);

N_EXTERN_LIBRARY(int)
CCS_PacketReSign(
	NICI_CC_HANDLE					cryptoContext,
	nuint32   						encodedLen,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					signature,
	pnuint32      					signatureLen);

N_EXTERN_LIBRARY(int)
CCS_PacketSign(
	NICI_CC_HANDLE					cryptoContext,
	nuint32   						encodedLen,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					signature,
	pnuint32      					signatureLen);

N_EXTERN_LIBRARY(int)
CCS_PacketSignInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_SetAttributeValue(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			object,
	NICI_ATTRIBUTE_PTR			attrTemplate,
	nuint32   						count);

N_EXTERN_LIBRARY(void)
CCS_Shutdown(void);

N_EXTERN_LIBRARY(int)
CCS_Sign(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					signature,
	pnuint32      					signatureLen);

N_EXTERN_LIBRARY(int)
CCS_SignFinal(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					signature,
	pnuint32      					signatureLen);

N_EXTERN_LIBRARY(int)
CCS_SignInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_SignRecover(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					signature,
	pnuint32      					signatureLen);

N_EXTERN_LIBRARY(int)
CCS_SignRecoverInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_SignRecoverRestart(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_SignRestart(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_SignUpdate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					part,
	nuint32   						partLen);

N_EXTERN_LIBRARY(int)
CCS_UnwrapKey(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			unwrappingKey,
	pnuint8      					wrappedKey,
	nuint32   						wrappedKeyLen,
	NICI_OBJECT_HANDLE_PTR		key);

N_EXTERN_LIBRARY(int)
CCS_UnwrapSessionKey(
	pnuint8      					wrappedKey,
	nuint32   						wrappedKeyLen,
	nint32    						wrappedKeyVersion,
	NICI_OBJECT_HANDLE_PTR		hKey);

N_EXTERN_LIBRARY(int)
CCS_Verify(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					data,
	nuint32   						dataLen,
	pnuint8      					signature,
	nuint32   						signatureLen);

N_EXTERN_LIBRARY(int)
CCS_VerifyFinal(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					signature,
	nuint32   						signatureLen);

N_EXTERN_LIBRARY(int)
CCS_VerifyInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_VerifyRecover(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					signature,
	nuint32   						signatureLen,
	pnuint8      					data,
	pnuint32      					dataLen);

N_EXTERN_LIBRARY(int)
CCS_VerifyRecoverInit(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_VerifyRecoverRestart(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_VerifyRestart(
	NICI_CC_HANDLE					cryptoContext,
	NICI_OBJECT_HANDLE			key);

N_EXTERN_LIBRARY(int)
CCS_VerifyUpdate(
	NICI_CC_HANDLE					cryptoContext,
	pnuint8      					part,
	nuint32   						partLen);

N_EXTERN_LIBRARY(int)
CCS_WrapKey(
	NICI_CC_HANDLE					cryptoContext,
	NICI_ALGORITHM_PTR			algorithm,
	NICI_KM_STRENGTH				kmLevel,
	NICI_OBJECT_HANDLE			sealingKey,
	NICI_OBJECT_HANDLE			wrappingKey,
	NICI_OBJECT_HANDLE			key,
	pnuint8      					wrappedKey,
	pnuint32      					wrappedKeyLen);

#endif    /*   _CCS_H_ */

