/****************************************************************************
*
* 1995 (C) Unpublished Copyright Novell, Inc. All Rights Reserved.
*
* No part of this file may be duplicated, revised, translated,
* localized or modified in any manner or compiled, linked or 
* uploaded or downloaded to or from any computer system without
* the prior written consent of Novell, Inc.
*
*****************************************************************************/

#if !defined(NOVELL_NLSAPI_INCLUDED)
#define NOVELL_NLSAPI_INCLUDED

typedef LS_STR *	LS_LICENSE_ID;
typedef struct LS_TRANS_ENTRY_TAG
	{
	LS_STR FAR		*actionName;
	LS_ULONG			time;
	LS_STATUS_CODE	actionResult;
	LS_ULONG			numUnits;
	LS_STR FAR 		*userLoggedMessage;
	} LS_TRANS_ENTRY;

#define	LS_USER_NAME	0x00000000
#define	LS_MACHINE		0x00000001
#define	LS_FILE_SERVER	0x00000002

#if defined(__cplusplus)
extern "C"
	{
#endif

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSInstalled(
	LS_STR FAR *licenseSystem, LS_STR FAR *serverName, LS_STR FAR *publisher,
	LS_STR FAR *product, LS_STR FAR *version, LS_ULONG maxStrLen,
	LS_STR FAR *installedPublisher, LS_STR FAR *installedProduct,
	LS_STR FAR *installedVersion,	LS_LICENSE_ID installedLicID,
	LS_ULONG FAR *numInstalledUnits,	LS_ULONG FAR *index);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSInUse(
	LS_STR FAR *licenseSystem, LS_STR FAR *serverName, LS_STR FAR *publisher,
	LS_STR FAR *product, LS_STR FAR *version, LS_ULONG maxStrLen,
	LS_STR FAR *publisherInUse, LS_STR FAR *productInUse,
	LS_STR FAR *versionInUse, LS_LICENSE_ID licIDInUse,
	LS_ULONG FAR *numUnitsInUse, LS_ULONG FAR *index);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSAvailable(
	LS_STR FAR *licenseSystem, LS_STR FAR *serverName, LS_STR FAR *publisher,
	LS_STR FAR *product, LS_STR FAR *version, LS_ULONG maxStrLen,
	LS_STR FAR *availablePublisher, LS_STR FAR *availableProduct,
	LS_STR FAR *availableVersion,	LS_LICENSE_ID availableLicID,
	LS_ULONG FAR *availableUnits, LS_ULONG FAR *index);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSUsers(
	LS_STR FAR *licenseSystem, LS_STR FAR *serverName, LS_STR FAR *publisher,
	LS_STR FAR *product, LS_STR FAR *version, LS_ULONG maxStrLen,
	LS_STR FAR *publisherInUse, LS_STR FAR *productInUse,
	LS_STR FAR *versionInUse, LS_LICENSE_ID licIDInUse,
	LS_ULONG FAR *unitsInUse, LS_STR FAR *user, LS_ULONG FAR *index);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSAddAssignment(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisher, LS_STR FAR *product,
	LS_STR FAR *version, LS_LICENSE_ID licenseID, LS_ULONG assignmentType,
	LS_VOID FAR *assignmentInfo, LS_ULONG assigmentInfoLen);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSRemoveAssignment(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisher, LS_STR FAR *product,
	LS_STR FAR *version, LS_LICENSE_ID licenseID, LS_ULONG assignmentType,
	LS_VOID FAR *assignmentInfo, LS_ULONG assignmentInfoLen);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSTransferOwnership(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisher, LS_STR FAR *product,
	LS_STR FAR *version, LS_LICENSE_ID licenseID, LS_STR FAR *newOwner);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSGetTransaction(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisher, LS_STR FAR *product,
	LS_STR FAR *version, LS_STR FAR *userName, LS_ULONG maxStrLen,
	LS_HANDLE FAR *transactionHandle, LS_STR FAR *transactionPublisher,
	LS_STR FAR *transactionProduct, LS_STR FAR *transactionVersion,
	LS_STR FAR *transactionUserName,	LS_ULONG FAR *index);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSGetEntry(
	LS_HANDLE transactionHandle, LS_TRANS_ENTRY FAR *transactionEntry,
	LS_ULONG FAR *index);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSInstallCertificate(
	LS_STR FAR *licenseSystem, LS_STR FAR *serverName, LS_ULONG licenseLength,
	LS_VOID FAR *licenseCertificate, LS_ULONG passwordLength,
	LS_VOID FAR *activationPassword);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSMoveCertificate(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisherName, LS_STR FAR *productName,
	LS_STR FAR *version, LS_LICENSE_ID licenseID, LS_STR FAR *newServerName);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSDeleteCertificate(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisherName, LS_STR FAR *productName,
	LS_STR FAR *version, LS_LICENSE_ID licenseID);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSGetCertificate(
	LS_STR FAR *licenseSystem, LS_STR FAR *publisherName,
	LS_STR FAR *productName, LS_STR FAR *version, LS_LICENSE_ID licenseID,
	LS_ULONG maxBufferLen, LS_VOID FAR *licenseCertificate,
	LS_ULONG FAR *actualBufferLen);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSCertificateTagToMessage(
	LS_VOID FAR *licenseCertificate, LS_ULONG licenseCertificateLength,
	LS_ULONG maxStringLen, LS_STR FAR *messageString, LS_ULONG FAR *tagNumber);

extern LS_STATUS_CODE N_LSAPI_FUNCDEF NLSAddProductInformation(
	LS_STR FAR *licenseSystem, LS_STR FAR *serverName, LS_STR FAR *publisherName,
	LS_STR FAR *productName, LS_STR FAR *version, LS_ULONG licenseUnits,
	LS_ULONG attributesLength, LS_VOID FAR *licenseAttributes);

#if defined(__cplusplus)
	};
#endif

#endif // NOVELL_NLSAPI_INCLUDED
