/****************************************************************************
 *
 * (C) Copyright 1989-1995 Novell, Inc.
 * All Rights Reserved.
 *
 * This program is an unpublished copyrighted work which is proprietary
 * to Novell, Inc. and contains confidential information that is not
 * to be reproduced or disclosed to any other person or entity without
 * prior written consent from Novell, Inc. in each and every instance.
 *
 * WARNING:  Unauthorized reproduction of this program as well as
 * unauthorized preparation of derivative works based upon the
 * program or distribution of copies by sale, rental, lease or
 * lending are violations of federal copyright laws and state trade
 * secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/

/* Keep the following PRIVATE */

/* Function prototypes */
LONG  GetDeviceMediaObject(
   struct ObjectDef             *object,
   struct ObjectDef            **mediaobject);

LONG  AddPartitionToMirrorGroup(
   LONG                          npartitionnumber,
   LONG                          partitionnumber);

LONG  DeletePartitionFromMirrorGroup(
   LONG                          partitionnumber);

LONG  CreateMirror(
   LONG                          partitionnumber);

LONG  DeleteMirror(
   LONG                          partitionnumber);

LONG  CreateRedirection(
   LONG                          partitionnumber,
   LONG                          logicalsize);

LONG  DeleteRedirection(
   LONG                          partitionnumber);

LONG  SynchronizeMirroredPartition(
   LONG                          partitionnumber);

LONG  UnsynchronizeMirroredPartition(
   LONG                          partitionnumber);

LONG  ReturnMirrorInfo(
   LONG                          partitionnumber,
   struct MirrorInfoStruct      *info);

/* From MMPART.C */

struct PartDef
{
   BYTE  bootflag;
   BYTE  bhead;
   BYTE  bsector;
   BYTE  bcylinder;
   BYTE  sysflag;
   BYTE  ehead;
   BYTE  esector;
   BYTE  ecylinder;
   LONG  beginningsector;
   LONG  numberofsectors;
};


/* Partition Types */
#define NETWARE_PARTITION_286 0x64
#define NETWARE_PARTITION_386 0x65
#define NETWARE_PARTITION_SMS 0x66

#define CREATEANYPARTITION          0
#define INITIALIZEPARTITIONTABLE    1
#define RETURNBOOTTABLEINFO         2
#define DELETEANYPARTITION          3

/* Make the following PUBLIC */

/* BE SURE TO ALSO CHANGE THE FILE MM.H IF ANY OF THESE ARE CHANGED */

/* Defines and structures for MM_ReturnPartitionTableInfo() */

/* For partitionStatus parameter */
#define MM_PARTITION_VALID          0
#define MM_PARTITION_NONE           1
#define MM_PARTITION_INCONSISTENT   2
#define MM_PARTITION_INVALID        3

#define NUMBER_OF_PART_STRUCTS      8

struct MM_PartitionInfoStruct
{
   BYTE  partitionName[32];   /* Type of partition as an ASCII string
                                    (e.g., "NetWare Partition") */
   LONG  beginningSector;     /* Beginning sector number of the physical
                                    partition */
   LONG  numberOfSectors;     /* Number of sector in the physical partition */
   LONG  objectID;            /* Media Manager ObjectID of a defined
                                    partition for this physical partition, if
                                    any. -1 means none */
   LONG  bootFlag;            /* Boot flag of the partition entry */
};


/* Defines and structures for MM_ReturnMirrorInfo() */

/*  Bit values for status field */
#define MIRRORGROUPINSYNCH             0x01  /* The mirror group is in sync */
#define MIRRORGROUPALLHERE             0x02  /* All parts of the mirror are
                                                   present */
#define MIRRORGROUPOPERATIONAL         0x04  /* The mirror group is
                                                   operational */
#define IAMINSYNCH                     0x10  /* If any partition in the group
                                                   is in sync */
#define MIRRORGROUPBEINGREMIRRORED     0x40  /* The mirror group is being
                                                   remirrored*/
struct MM_MirrorInfoStruct
{
   WORD     status;              /* an OR of bits indicated above */
   WORD     mirrorcount;         /* number of paritions inc this one in the
                                       mirror group */
   LONG     mirroridentifier;    /* partition number of the original parition
                                       in the mirror group */
   LONG     mirrormembers[16];   /* array of the partitions which make up
                                       this mirro group */
   LONG     remirrorpercentage;  /* percentage of partition which is mirrored
                                       range 0 - 99 */
   LONG     reserved[7];
};

/*

   Function prototypes for Volume APIs

*/

LONG MM_InitializeBootTable(
   LONG                          deviceObjectHandle);

LONG MM_CreatePartition(
   LONG                          deviceObjectHandle,
   LONG                          partitionType,
   LONG                          startingSector,
   LONG                          numberOfSectors,
   LONG                         *newPartitionObjectID);
   
LONG MM_DeletePartition(
   LONG                          deviceObjectHandle,
   LONG                          partitionType,
   LONG                          startingSector,
   LONG                          numberOfSectors);

LONG Internal_ReturnPartitionTableInfo(
   LONG                          objectindex,
   void                         *vinfo);

LONG MM_ReturnPartitionTableInfo(
   LONG                          deviceObjectHandle,
   LONG                         *partitionTableStatus,
   LONG                         *alignment,
   LONG                         *areaStart,
   LONG                         *areaLength,
   LONG                         *partitionCount,
   struct MM_PartitionInfoStruct *partitionInfo);

LONG MM_CreateHotFix(
   LONG                          partitionObjectHandle,
   LONG                          logicalSize,
   LONG                         *newHotFixObjectID);

LONG MM_DeleteHotFix(
   LONG                          hotFixObjectID);

LONG MM_CreateMirror(
   LONG                          partitionObjectHandle,
   LONG                         *newMirrorObjectID);

LONG MM_DeleteMirror(
   LONG                          mirrorObjectID);

LONG MM_AddMirrorObjectToMirrorGroup(
   LONG                          mirrorObjectID,
   LONG                          mirrorGroupObjectID);

LONG MM_DelParitionFromMirrorGroup(
   LONG                          partitionObjectID);

LONG MM_ForceMirrorGroupInSync(
   LONG                          mirrorGroupObjectID);
   
LONG MM_RemirrorGroup(
   LONG                          mirrorGroupObjectID,
   LONG                          modeFlags);
  
LONG MM_ReturnMirrorInfo(
   LONG                          mirrorObjectID,
   struct MM_MirrorInfoStruct   *mirrorInfo);

/* End of function prototypes for volume APIs */
