/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_ATR.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_ATR_H )
   #define NWDP_ATR_H

/* Standard Library Header Includes */
   #if !defined(NWDP_LIB_H)
      #include <nwdp_lib.h>
   #endif

   #if !defined(NWDP_ATT_H)
      #include <nwdp_att.h>
   #endif

/* Header Includes */

/* Manifest Constant Definitions */
   #define NWDP_AS_DEFAULT_SET_SIZE    ((nuint)-1)

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

   typedef struct
   {
      NWDPAttributeSet  attrSet;

      nuint reserved1;
      nptr  reserved2;
      nuint reserved3;

   } NWDPAttrSetStruct, N_FAR *pNWDPAttrSetStruct;


   /*
   // Attribute and Value pointer (AVP) control block
   */
   typedef struct 
   {
      NWDPAttrSetRef             attrSetRef; 
      pNWDPAttribute             attrPtr;
      pNWDPAttributeValue        valuePtr;

   } NWDPASAVPStruct, N_FAR *pNWDPASAVPStruct;


   typedef struct 
   {
      pNWDPOid       attributeIdPtr;
      nuint32        qualifier;
      NWDPASAVPRef   avpRef;
   } NWDPASAttributeListItem, N_FAR *pNWDPASAttributeListItem;


   typedef struct 
   {
      pNWDPObjectIdentification objectIdentPtr;
      pNWDPAttributeSet         attrSetPtr;
      pNWDPOid                  objectClassPtr;
   } NWDPASMODObjectListItem, N_FAR *pNWDPASMODObjectListItem;


   typedef struct 
   {
      nuint                       scope;
      NWDPObjectIdentificationSeq objectIdentSeq;
      NWDPFilterRef               filterRef;
      nint32                      timeLimit;
      nint32                      countLimit;
   } NWDPASSelector, N_FAR *pNWDPASSelector;


#include <npackoff.h>

/* Callback Definitions */

 N_TYPEDEF_CALLBACK(nint,
NWDPASAttributeListCallback)(
   NWDPAccessorRef          accessorRef,
   nparam                   callerDefinedParam,
   nint                     totalCallsToBeMade,
   nint                     currentCallCount,
   pNWDPASAttributeListItem attributeListItemPtr
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPASAttrValueListCallback)(
   NWDPAccessorRef     accessorRef,
   nparam              callerDefinedParam,
   nint                totalCallsToBeMade,
   nint                currentCallCount,
   NWDPASAVPRef        avpRef
   );

 N_TYPEDEF_CALLBACK(nint,
NWDPASMODObjectListCallback)(
   NWDPAccessorRef            accessorRef,
   nparam                     callerDefinedParam,
   nint                       totalCallsToBeMade,
   nint                       currentCallCount,
   pNWDPASMODObjectListItem   objectPtr
   );

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPASAddAttribute(
   NWDPAccessorRef accessorRef,
   NWDPASAVPRef    avpRef,
   pNWDPOid        attributeIdPtr,
   pnuint32        qualifierPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASAddAttrValue(
   NWDPAccessorRef     accessorRef,
   NWDPASAVPRef        avpRef,
   pNWDPOid            attributeIdPtr,
   pNWDPAttributeValue valuePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASCreateRef(
   NWDPAccessorRef accessorRef,
   nuint           sizeOfAttrSet, /* e.g. NWDP_AS_DEFAULT_SET_SIZE */
   pNWDPAttrSetRef attrSetRefPtr,
   pNWDPASAVPRef   avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASCreateRefBasedOnSet(
   NWDPAccessorRef   accessorRef,
   pNWDPAttributeSet attributeSetPtr,
   pNWDPAttrSetRef   attrSetRefPtr,
   pNWDPASAVPRef     avpRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASListAttributes(
   NWDPAccessorRef             accessorRef,
   NWDPASAVPRef                avpRef,
   NWDPASAttributeListCallback listCallback,
   nparam                      callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPASListAttrValues(
   NWDPAccessorRef               accessorRef,
   NWDPASAVPRef                  avpRef,
   pNWDPOid                      attributeIdPtr,
   NWDPASAttrValueListCallback   listCallback,
   nparam                        callerDefinedParam
   );

 N_EXTERN_LIBRARY(nint)
NWDPASMakeAVPRef(
   NWDPAccessorRef   accessorRef,
   NWDPAttrSetRef    attrSetRef,
   NWDPASAVPRef      avpRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPASModifyAttrValue(
   NWDPAccessorRef     accessorRef,
   NWDPASAVPRef        avpRef,
   pNWDPOid            attributeIdPtr,
   pNWDPAttributeValue oldValuePtr,
   pNWDPAttributeValue newValuePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASReleaseRef(
   NWDPAccessorRef accessorRef,
   pNWDPAttrSetRef attrSetRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASRemoveAttribute(
   NWDPAccessorRef accessorRef,
   NWDPASAVPRef    avpRef,
   pNWDPOid        attributeIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASRemoveAttrValue(
   NWDPAccessorRef      accessorRef,
   NWDPASAVPRef         avpRef,
   pNWDPOid             attributeIdPtr,
   pNWDPAttributeValue  valuePtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASSetAVPByAttributeId(
   NWDPAccessorRef   accessorRef,  
   NWDPASAVPRef      avpRef, 
   pNWDPOid          attributeIdPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPASSetModifyOperators(
   NWDPAccessorRef          accessorRef,
   NWDPASAVPRef             avpRef,
   NWDPModifyOperatorEnum operation,
   nbool                    applyToAll
   );

 N_EXTERN_LIBRARY(nint)
NWDPASUseRef(
   NWDPAccessorRef accessorRef,
   NWDPAttrSetRef attrSetRef
   );

 N_EXTERN_LIBRARY(nint)
NWDPASValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPAttrSetRef  attrSetRef
   );


#else /* NWDP_ATR_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_atr.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_ATR_H */
