/*
//ͻ
// (c) 1995-1998 Novell, Inc.  All rights reserved.                         
//                                                                          
// THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND        
// TREATIES.                                                                
//                                                                          
// NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          
// DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         
// EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    
// WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        
//                                                                          
// ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT 
// THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         
//͹
// Source module name: NWDP_FLT.H                                           
//͹
// Library VeRsIoN=1.1.0                                                    
//ͼ
*/
/* Inclusion Control */
#if !defined( NWDP_FLT_H )
   #define NWDP_FLT_H

/* Standard Library Header Includes */
   #if !defined(NWDP_ATR_H)
      #include <nwdp_atr.h>
   #endif
   #if !defined(NWDP_ATT_H)
      #include <nwdp_att.h>
   #endif


/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */
#define N_PACK_1
#include <npackon.h>

typedef enum {
   NWDP_FLT_DELIM_AND         = 1,
   NWDP_FLT_DELIM_OR          = 2,
   NWDP_FLT_DELIM_NOT         = 3,
   NWDP_FLT_DELIM_LPAREN      = 9,
   NWDP_FLT_DELIM_RPAREN      = 10,
   NWDP_FLT_DELIM_END         = 11
} NWDPFilterDelimiter, N_FAR *pNWDPFilterDelimiter;

typedef enum {
   NWDP_FLT_MATCH_EQUAL       = 0,
   NWDP_FLT_MATCH_GE          = 2,
   NWDP_FLT_MATCH_LE          = 3,
   NWDP_FLT_MATCH_PRESENT     = 4,  /*
                                    // Match if requested attribute has
                                    // any value. (i.e. its value exists)
                                    */
   NWDP_FLT_MATCH_SUBSET      = 5,  /*
                                    // Match if requested value set is 
                                    // completely contained in the list 
                                    // of values belonging to an attribute.
                                    */
   NWDP_FLT_MATCH_SUPERSET    = 6,  /*
                                    // Match if all values are within
                                    // the requested set.
                                    */
   NWDP_FLT_MATCH_NON_DISJOINT= 7   /*
                                    // Match if any value is within the
                                    // requested set.
                                    */
} NWDPFilterAttrSetMatch, N_FAR *pNWDPFilterAttrSetMatch;

#include <npackoff.h>

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

 N_EXTERN_LIBRARY(nint)
NWDPFltCreateRef(
   NWDPAccessorRef accessorRef,
   pNWDPFilterRef filterRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPFltDestroyRef(
   NWDPAccessorRef accessorRef,
   pNWDPFilterRef filterRefPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPFltAppendDelimiter(
   NWDPAccessorRef accessorRef,
   NWDPFilterRef filterRef,
   NWDPFilterDelimiter delimiter
   );

 N_EXTERN_LIBRARY(nint)
NWDPFltAppendAttrSetMatch(
   NWDPAccessorRef accessorRef,
   NWDPFilterRef filterRef,
   NWDPASAVPRef    avpRef,
   NWDPFilterAttrSetMatch matchFlag
   );

 N_EXTERN_LIBRARY(nint)
NWDPFltAppendSubstringMatch(
   NWDPAccessorRef   accessorRef,
   NWDPFilterRef     filterRef,
   pNWDPSubStrings   attrSubstringMatchPtr
   );

 N_EXTERN_LIBRARY(nint)
NWDPFltValidateRef(
   NWDPAccessorRef accessorRef,
	NWDPFilterRef filterRef
   );

#else /* NWDP_FLT_H is defined. */

   #if defined(N_DEBUG)
      #error nwdp_flt.h has already been included.
   #endif /* N_DEBUG */

#endif /* NWDP_FLT_H */
